from dataclasses import dataclass
from typing import Final
import os


@dataclass(frozen=True)
class Constants:

    SP_CLIENT_VERSION: Final[str] = '1.0.0'

    HOME: Final[str] = os.path.expanduser('~')

    SYSTEM_CONFIG_PATH: Final[str] = '/etc'

    CONFIG_HOME: Final[str] = os.environ.get('XDG_CONFIG_HOME') or os.path.join(HOME, '.config')
    DATA_HOME: Final[str] = os.environ.get('XDG_DATA_HOME') or os.path.join(HOME, '.local/share')
    STATE_HOME: Final[str] = os.environ.get('XDG_STATE_HOME') or os.path.join(HOME, '.local/state')

    SP_SYSTEM_CONFIG_PATH: Final[str] = f'{SYSTEM_CONFIG_PATH}/simplified-privacy'

    SP_CONFIG_HOME: Final[str] = f'{CONFIG_HOME}/simplified-privacy'
    SP_DATA_HOME: Final[str] = f'{DATA_HOME}/simplified-privacy'
    SP_STATE_HOME: Final[str] = f'{STATE_HOME}/simplified-privacy'

    SP_SYSTEM_PROFILE_CONFIG_PATH: Final[str] = f'{SP_SYSTEM_CONFIG_PATH}/profiles'

    SP_PROFILE_CONFIG_HOME: Final[str] = f'{SP_CONFIG_HOME}/profiles'
    SP_PROFILE_DATA_HOME: Final[str] = f'{SP_DATA_HOME}/profiles'

    SP_APPLICATION_DATA_HOME: Final[str] = f'{SP_DATA_HOME}/applications'

    SP_SESSION_STATE_HOME: Final[str] = f'{SP_STATE_HOME}/sessions'

    SP_STORAGE_DATABASE_PATH: Final[str] = f'{SP_DATA_HOME}/storage.db'

    SP_API_BASE_URL: Final[str] = 'https://api.simplifiedprivacy.is/api/v1'
